unit Umain;

interface


type
  my_bool = byte;
  pCardinal=^Cardinal;
  pByte=^Byte;

  PUDF_INIT=^TUDF_INIT;
  TUDF_INIT=record
     maybe_null:my_bool;             { 1 if function can return NULL }
     decimals: cardinal;             { for real functions }
     max_length: cardinal;           { For string functions }
     ptr:PCHAR;                      { free pointer for function data }
     const_item:my_bool;             { 0 if result is independent of arguments }
  end;


  TItem_results=(STRING_RESULT,REAL_RESULT,INT_RESULT);

  PItem_result_set=^TItem_result_set;
  TItem_result_set=set of TItem_results;



  PARGS=^TARGS;
  TARGS = array[0..MaxInt div SizeOf(pChar) - 1] of pChar;

  PUDF_ARGS=^TUDF_ARGS;
  TUDF_ARGS=record
     arg_count:Cardinal;             { Number of arguments }
     arg_type:PItem_result_set;          { Pointer to item_results }
     args:PARGS;                     { Pointer to argument }
     lengths: pCardinal;             { Length of string arguments }
     maybe_null:pByte;               { Set to 1 for all maybe_null args }
  end;

function TEST(initid:PUDF_INIT;args:PUDF_ARGS;Aresult:PCHAR;Alength:pCardinal;is_null:PChar;error:PChar):PChar;stdcall;export;

function TEST_INIT(initid:PUDF_INIT;args:PUDF_ARGS;aMessage:PChar):my_bool;stdcall;export;
procedure TEST_DEINIT(initid:PUDF_INIT);stdcall;export;

{my_bool metaphon_init(UDF_INIT *initid, UDF_ARGS *args, char *message);
void metaphon_deinit(UDF_INIT *initid);

char *metaphon(UDF_INIT *initid, UDF_ARGS *args, char *result,
	       unsigned long *length, char *is_null, char *error);
}


implementation

function TEST(initid:PUDF_INIT;args:PUDF_ARGS;Aresult:PCHAR;Alength:pCardinal;is_null:PChar;error:PChar):PChar;
begin
  Result:='This is test';
end;

function TEST_INIT(initid:PUDF_INIT;args:PUDF_ARGS;aMessage:PChar):my_bool;
begin
  Result:=0;
end;

procedure TEST_DEINIT(initid:PUDF_INIT);
begin

end;


end.
